USE_BOX_MENU    equ 1
;DEBUGGING       equ 1
HRL equ ""
ifdef USE_BOX_MENU
TTL equ " PC-98I{[hIDE ɐڑꂽfBXN̗eʏk Version 1.03  (C)2023 ܂"
else 
TTL equ " PC-98I{[hIDE ɐڑ̃fXN RUTMB ɏk Version 1.03  (C)2023 ܂"
endif
;HR2 equ ""
;"hcd"
include     ideports.h
code            segment
                assume cs:code, ds:code, es:code, ss:code
                org 0100h
                ; ύXs
start:          JMP     begin   ; ȉ̃f[^ubN FDLOADERAvƂ
                DB      0,"FDLOADERAPP"         ; Kvȍ\Ȃ̂ŕύXs
                DW      0
                DB      "2023/07/30 102",0
msg_ttl         DB      0E1h,TTL,13,10,0      ; vO^Cg

.386
include datablk.s
;----------------------------------------
begin:          nop
                nop
                nop
                call    CheckEnvFDLD
                test    flagset,F_FDLOADER
                jz      begin2
                cli     ; In FDLOADER
                mov     ax,cs
                mov     ds,ax
                mov     es,ax
                mov     ss,ax
                mov     sp, (offset stack_base)+1024
                sti
begin2:         
                call    ClearScreen24
                call    ResumeTitle
                call    DisplayTitle
                call    DisplayConn4
                test    flagset,F_FDLOADER
ifNdef DEBUGGING
                jz      @f
endif
                mov     dx,offset startup_w
                call    _puts
        @@:     call    SelectDevice
                jc      ExitProgram
                call    Switch0432h
                call    Delete4Line
                call    TitlePortName
                call    DisplayTitle

                mov     ATA_CMD,0ECh
                call    IdentifyIDE
                jnc     Display_ATA
                mov     dx,offset err_ATA
                call    _puts
                call    Beep1
                mov    ATA_CMD,0A1h
                call    IdentifyIDE
                jc      @f
                call    GetDeviceName
                call    GetFirmNumber
                mov     dx,offset msg_HDMODEL
                call    _puts
                mov     dx,offset string_model
                call    _puts
                mov     dx,offset msg_CRLF
                call    _puts
                mov     dx,offset msg_FIRMWARE
                call    _puts
                mov     dx,offset string_fwversion
                call    _puts
        @@: 
                JMP     CancelCapaSet
Display_ATA:    ;--------------------
                call    Capability
                call    GetDeviceName
ifNdef DEBUGGING
                call    GetSerialNumber
endif
                call    GetFirmNumber
                call    DisplayChars3
                call    GetCapaLBA
                jc      ExitProgram

                mov     dx,offset msg_TotalLBA
                call    _puts
                mov     eax,TotalLBA
                call    DisplayCapacity

                test    flagset,F_48BIT
                jz      @f
                call    DisplayCapa48
        @@:     

                mov     cs:ErrCount,0
ReadNativeMaxEntry:
                call    ReadNativeMax
                jnc     @f
                inc     cs:ErrCount
                cmp     cs:ErrCount,2
                jb      ReadNativeMaxEntry
                mov     dx,offset err_readmax_EX
                call    _puts
        @@:     
                test    flagset,F_48BIT
                jz      @f

                mov     cs:ErrCount,0
ReadNativeMax48Entry:
                call    ReadNativeMax48
                jnc     @f
                inc     cs:ErrCount
                cmp     cs:ErrCount,2
                jb      ReadNativeMax48Entry
                mov     dx,offset err_readmax
                call    _puts
                jmp     ExitProgram     ; G[őIȂ悤ɂ0.12
        @@:

                call    DisplayWord0_76
                call    DisplayWord01_06
                call    DisplayWord54_56

                test    flagset,F_SETMAX
                jnz     @f
                call    ShortBeep
                mov     dx,offset msg_nosetmax
                call    _puts
;;;;;           jmp     ExitProgram
        @@:     
                call    Buuu    ;Warning
        
ifdef USE_BOX_MENU
                mov     dx,offset cmd_1U
                call    CommandLine
                mov     al,1
CapaMenu:       call    CapaCmdMenu
                cmp     al,00h
                je      CancelCapaSet
                cmp     al,01h
                je      Shrink543M
                cmp     al,02h
                je      Shrink2015M
                cmp     al,03h
                je      Shrink4G
                cmp     al,04h
                je      Shrink8Giga
                cmp     al,05h
                je      Shrink31Giga
                cmp     al,06h
                je      Shrink32G
                cmp     al,07h
                je      Shrink64G
                cmp     al,08h
                je      Shrink127G
                cmp     al,09h
                je      NoShrink
                call    KeyInput
                jmp     CapaMenu
ELSE
                mov     dx,offset msg_change
                call    _puts
                mov     dx,offset cmd_1B
                call    CommandLine
CapaMenu:       call    KeyInput
                cmp     al,0Bh  ;[-]
                je      Shrink365M
                cmp     al,40h  ;[-] of ten key
                je      Shrink365M
;               cmp     al,04h  ;[3]
;               je      Shrink4G
                cmp     al,00h  ;[ESC]
                je      CancelCapaSet
                cmp     al,1Ch  ;[CR]
                je      NoShrink
                jmp     CapaMenu
ENDIF
                mov     dx,offset cmd_non
                call    CommandLine
                jmp     ExitProgram

NoShrink:       mov     eax,AddrNativeMax28
                mov     DataLongL,eax            ; < 127GB
                mov     DataLongH,0
                test    flagset,F_48BIT
                jz      @f
                mov     eax,AddrNativeMax48
                mov     edx,AddrNativeMax48H
                mov     DataLongL,eax            ; all 
                mov     DataLongH,edx            ; 
        @@:     mov     bx,offset cmd_res
                jmp     Shrink

IFDEF USE_BOX_MENU
Shrink127G:     mov     DataLongL,0FFFF800h-1    ; 131071MB
                mov     DataLongH,0
                mov     bx,offset cmd08
                jmp     Shrink
Shrink64G:      mov     DataLongL,07FFF800h-1    ; 65535MB
                mov     DataLongH,0
                mov     bx,offset cmd07
                jmp     Shrink
Shrink32G:      mov     DataLongL,03FFF800h-1    ; 32737MB
                mov     DataLongH,0
                mov     bx,offset cmd06
                jmp     Shrink

Shrink31Giga:   mov     DataLongH,0
                mov     DataLongL,03B0FC4Fh-0Fh    ; 30238MB
                mov     bl,NativeHead
                cmp     bl,15
                je      @f
                mov     DataLongL,03EFFC10h-10h    ; 32255MB 
         @@:    mov     bx,offset cmd05
                jmp     Shrink

Shrink8Giga:    mov     DataLongH,0
                mov     DataLongL,00EC3C4Fh-1    ; 7559MB 
                mov     bl,NativeHead
                cmp     bl,15
                je      @f
                mov     DataLongL,00FBFC10h-1    ; 8063MB
         @@:    mov     bx,offset cmd04
                jmp     Shrink

Shrink4G:       mov     DataLongL,87fff0h-1;      0087F800h-1    ;4351MB
                mov     DataLongH,0
                mov     bx,offset cmd03
                jmp     Shrink

Shrink2015M:    mov     DataLongH,0
                mov     DataLongL,03b089Eh-1  ; 1889MB
                mov     bl,NativeHead
                cmp     bl,15
                je      @f
                mov     DataLongL,3EF820h-1    ; 2015MB
         @@:    mov     bx,offset cmd02
                jmp     Shrink

Shrink543M:     mov     DataLongL,0010FF78h-1    ;543MB
                mov     DataLongH,0
                mov     bx,offset cmd01
                jmp     Shrink
ENDIF
Shrink365M:     mov     DataLongL,CAPA365M
                mov     DataLongH,0
                mov     bx,offset cmd10
;;;;;;          jmp     Shrink
Shrink:

IFDEF USE_BOX_MENU
                mov     COLUMN,0
                mov     si,cs:Win_BYTE
                shr     si,1
                inc     si
                inc     si
                mov     ax,0
                mov     [bx+si],ax
                mov     ax,9A81h        ;  space
                mov     [bx+1],ax
                mov     dx,bx   ; 
                call    _puts
                mov     dx,offset msg_CRLF
                call    _puts
ENDIF
                mov     dx,offset cmd_3
                call    CommandLine
if 0
                mov     eax,DataLongL
                inc     eax
                call    DisplayCapacity
endif

                test    flagset,F_48BIT
                jnz     Use48bit
                call    SetMaxAddress
                jmp     EndSetMax
Use48bit:       call    SetMaxAddress48
EndSetMax:      
                jnc     SetMaxOK
                mov     dx,offset msg_shrink_err
                call    _puts
                call    Beep1; ShortBeep
                mov     dx,offset msg_ATARSTtime
                call    _puts
                JMP     ExitProcess
SetMaxOK:
                mov     dx,offset msg_luck
                call    _puts
                call    BeepWarning
                JMP     ExitProcess

CancelCapaSet:  ; eʕύXsȂꍇ
                mov     dx,offset cmd_r
                call    CommandLine
NextMenu:       
                call    KeyInput
                cmp     al,00h
                je      ExitProcess
                cmp     al,13h  ; 'R'
                je      begin3
                cmp     al,1Ch  ; '(enter)'
                je      begin3
                jmp     NextMenu
begin3:         ; call    SwitchSlave
                call    Resume0432h
                jmp     begin2

;========================ŏIɂ=================
ExitProcess:
                call    Resume0432h
                mov     dx,offset cmd_non
                call    CommandLine
ExitProgram:    
                test    flagset,F_FDLOADER
                jnz     @f
                test    flagset,F_InDOS
                jz      @f
                mov     dl,1
                mov     dh,22
                mov     ah,03h
                mov     cl,10h
                int     0DCh
                mov     dx,offset disp_fkline
                mov     ah,9h
                int     21h
                mov     ah,4Ch
                int     21h
           @@:  
                mov     dx,offset cmd_0 ; [ESC]Iēd؂鏀 
                call    CommandLine
EndMenu0:       call    KeyInput
                cmp     al,00h  ; [ESC] = I
                je      FinishProgram
                cmp     al,1Ch  ; [Enter]=u[g
                jne     EndMenu0
                mov     dx,offset cmd_non
                call    CommandLine
                JMP     ShutDown
                jmp     $
                
FinishProgram:  test    flagset,F_FDLOADER
                jz      @f
                mov     dx,offset cmd_rbt   ; FDLOADER
                call    CommandLine
                HLT
                jmp     $
      @@:       mov     dx,offset cmd_rbt   ; BIOS
                call    CommandLine
                xor     ax,ax
                int     18h
                call    ShutDown
                jmp     $
disp_fkline     DB      1Bh,"[>1l$",0
;======================================END=====================
include sub.s
include reboot.s
include seldev4.s
include ident.s
include readmax.s
include dispinfo.s
include pdmenu.s
;-------------------------------
include e:\asmlib\putstrcs.inc
include e:\asmlib\digit.inc
include keyinput.s
include beep.s
;=====================================
msg_TCAPA    DB 0E1h,"h   e ",0
msg_MiB      DB 0E1h," MiB    ",0
msg_KiB      DB 0E1h," KiB",0
msg_GiB      DB 0E1h," GiB",0
msg28bitCR   DB 0E1h," (28bit)",13,10,0
phy_cyln        DB 0E1h,"lCeBu@V_ = ",0
msg_cyln        DB 0E1h,"WJ@@V_ = ",0
msg_head        DB 0E1h," , wbh = ",0
msg_sect        DB 0E1h," , ZN^ = ",0
msg_shrink      DB 0E1h,"eʂύX܂.",13,10,0
msg_shrink_err  DB 041h,"eʕύXŎs܂.",13,10,0
msg_CDm         DB 0E1h,"ATAPIfoCX͗eʕύXł܂̂ŏI܂.",13,10,0
err_readmax     DB 041h,"COMMAND ERROR: Read native max(F8)",13,10,0
err_readmax_EX  DB 043h,"COMMAND ERROR: Read native max EXT(big drive)",13,10,0
err_ATA         DB 041h,"ATAfoCX̐ڑmFł܂ł.",13,10,0
msg_luck        DB 0E1h,"^̗ǂƂ, eʂ̕ύXł܂.",13,10,0
msg_change      DB 0E1h,"̃fBXNhCu̗eʂύX܂.",13,10,0
cmd_res         DB 0E1h,"   eʂ{̒lɖ߂܂",13,10,0
msg_nosetmax    DB 041h,"̃foCX SET MAX ADDRESS T|[gĂ܂.",13,10,0
msg_OnlyCHS     DB 041h,"̃fBXNhCuLBAANZXł܂.",13,10,0
msg_ATARSTtime     DB 0E1h,"@iUd𗎂ƂɘAKpƃG[ɂȂhCu܂j",13,10,0
cmd_0   DB 085h,"@@@@   [ESC]Iēd؂鏀             [ENTER]u[g      ",0
cmd_1B  DB 065h," [ESC]~           [-]eʂ365MBɏk     [Enter]{̗eʂ𕜌       ",0
;cmd_1U  DB 0E1h,"    L[ŐݒeʂI[Enter]L[ĉ.",0
cmd_1A  DB 0C5h,"    [P]d؂Ăeʂێ          [T]d؂܂ŗLƂ  ",0
cmd_R   DB 085h,"@   [ESC] I         [R] ڑIDE|[gؑւčŏȂ     ",0
cmd_1U  label byte
cmd_3   DB 025h,"@                                                                          ",0
cmd_non DB 0E7h,"                               IĂ܂                               ",0
cmd_rbt DB 0C5h,"    ɏIĂ܂.  d؂čċNĂ.            ",0
cmd_ent DB 0A5h,"   [ESC]~      03܂ł̂ꂩ̐L[đI                ",0
;=======================================================
align 16
;;org     1000h
;SectBuf0        label   byte
;DW      256 dup(0E5E5h)

;;org     1400h
;SectBuf1        label   byte
;DW      256 dup(0E5E5h)

;;org     1800h
;SectBuf2        label   byte
;DW      256 dup(0FFFFh)

;;org     1C00h
HorisonLine   DB  021h,HRL,0

string_model     DB      0A1h
msgbuf0    DB      40 dup(20h),0

;msgbuf1   DB      "3.141592653589793238", 0

ifdef DEBUGGING
string_serial   DB     021h
msgbuf1         DB     " ******** ԍ铽  ", 0
ELSE 
string_serial   DB     0E1h
msgbuf1         DB     "******************* ", 0
ENDIF

string_fwversion DB      0E1h
msgbuf2   DB      8 dup(20h), 0

align 2
; The buffer of the return of Identify command
ID_Buffer   DW     100 dup (?)
LBA48_L     DD          ?
LBA48_H     DD          ?
;id_remnant  DW     154 dup (?) ; 256 words


stack_base      label   word

code    ends
        end start

