;-------------------------------------------------------------------
ToneSet         PROC    near
                push    dx
                mov     DX,03FDBh        ; 3FDB
                out     DX,AL
               xchg     AL,AH
                out     DX,AL
                pop     dx
                ret
ToneSet         ENDP


NoteTop         label   byte
;                        mi   re   do   so   sisi
;;;NoteData    dw    1350,750,600,675,500,533,600,450,500,400,450,337,675

;dw 1200,600,1350,675,1500,750,1000,500,1600,800

;            mi   re   do   so   sisi      la
;   DW      1200,1350,1500,1000,1600,1600,1800
; DW       600, 675, 750, 500, 800, 800
;DW      1800,1200, 900,1200,1500,3000
;NoteData  DW 1500,40,1000,1200,1600,40,1350,1000, 1500+10,1500-10,1500+10,1500
;NoteData  DW  1000,1200,40,1500,1500
;NoteData  DW  750,900,40,1000,40,1200,1350,1500,40,900
;NoteData  DW  750,800,40,1000,40,1000,40,1120,40,1120,1000,1000,1000
;                       so   mi  do re   so     do
;NoteData    DW      600,40,900,800,1200,40,900
NoteData    DW      1120,40,900,40,800,40,720,40,640,40,568,40,512,40,450,40,225

NoteTail        label   byte
                ;       1200,1500,900,1000
NoteData0       DW       800,1200,1080
NoteData0E      label   WORD
NoteData2       DW      600,750,450,500
NoteData2E      label   WORD

Beep0           PROC    near
                mov     si,offset NoteData0
                mov     ax,offset NoteData0E - offset NoteData0
                shr     ax,1
                mov     cx,ax
        @@:     lodsw
                call    beep0
               loop     @b
                mov     ax,1229
                call    Tone98Set
                ret
Beep0           ENDP

BeepWarning     PROC    near
                pusha
                mov     si,offset NoteData
                mov     ax,offset NoteTail - offset NoteTop
                shr     ax,1
                mov     cx,ax
BeepWarnEnt:    lodsw
                call    RingModSound
               loop     BeepWarnEnt
                mov     ax,1229
                call    Tone98Set
                popa    
                ret
BeepWarning     ENDP

Beep1           PROC    near
                pusha
                mov     si,offset NoteData2
                mov     ax,offset NoteData2E - offset NoteData2
                shr     ax,1
                mov     cx,ax
        @@:     lodsw
                call    RingModSound
               loop     @b
                mov     ax,1229
                call    Tone98Set
                popa
                ret
Beep1           ENDP


wavetable        label word
;;                dw      1010,240,400,2400,0
                dw      800,200,50,240,10,111,100,200,0
Ontei           dw      0001h

;-------------------------------------------------------------------
Tone98Set       PROC    near
                push    dx
                mov DX,03FDBh        ; 3FDB
                out DX,AL
               xchg AL,AH
                out DX,AL
                pop     dx
                ret
Tone98Set       ENDP
;-------------------------------------------------------------------
                PUBLIC  RingModSound
RingModSound    PROC    near
                mov     Ontei,ax
                push    si
                push    di
                push    cx
                mov     di,offset wavetable
                xor     dx,dx
;                mov     ax,39000
                mov     ax,20000   ; axŃe|߂
                div     Ontei
                mov     dx,ax
                cmp     word ptr cs:[si-2],450
                mov     si,122     ;1000
;                mov     si,160 ; SI𑝂₷ƍg
                ja     @f
                mov     si,7156 ; SI𑝂₷ƍg
           @@:
ENT_loop:
                add     si,29
                mov     ax,si
                and     ax,3
                mov     bx,ax
                mov     ax,cs:[bx+di]
                add     ax,si

                push    dx
                call    Tone98Set
                pop     dx

                mov     al,06
                out     37h,al

                mov     cx,Ontei
;                shl     cx,1
ENT_Onteiai:      
                out     05Fh,AL
               loop     ENT_Onteiai
                mov     al,07
                out     37h,al
                
                mov     cx,Ontei
                shr     cx,2
ENT_Onteiai2:     OUT     37h,AL
                OUT     5Fh,AL

               Loop     ENT_Onteiai2
                dec     dx
                cmp     dx,0
                jne     ENT_loop
                
                pop     cx
                pop     di
                pop     si
                ret
RingModSound            ENDP

wait11ms       PROC    near
                pushf
                cli
                push    ecx
                mov     ecx,10000
wait11ms_ent:   out     5F,al
                out     5F,al
                out     5F,al
               loopd    wait11ms_ent
                pop     ecx
                popf
                ret
wait11ms       ENDP

wait025s         PROC    near
                pushf
                cli
                push    ecx
                mov     ecx,84210
wait025s_ent:    out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
               loopd    wait025s_ent
                pop     ecx
                popf
                ret
wait025s         ENDP

wait0_1s         PROC    near
                pushf
                cli
                push    cx
                mov     cx,4000h
wait0_1s_ent:    out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
                out     5F,al
               loop    wait0_1s_ent
                pop     cx
                popf
                ret
wait0_1s         ENDP

;----------------------------------
tone_table      DW      320h,0h,0

do_             PROC   near
                mov     cx,38h
         @@:
                push    cx
                mov     al,6
                out     37h,al

                call    wait_5s
                mov     al,7
                out     37h,al

                mov     cx,060h
;                add     cx,0F0h
                call    wait_us
                pop     cx
               loop     @b
                ret
do_             ENDP


di_             PROC   near
                mov     cx,38h
         @@:
                push    cx
                mov     al,6
                out     37h,al
                call    wait_us
                mov     al,7
                out     37h,al
                mov     cx,080h
;                add     cx,0F0h
                call    wait_5s
                pop     cx
               loop     @b
                ret
di_             ENDP

;-------------------------------------------------------------------
Buuu            PROC   near
                push    bx
                push    dx
                push    ax
                push    si
                mov     si,offset tone_table
BuuuReent:
                mov     ax,[si]
                or      ax,ax
                jz      BuuuEnd
                mov     cx,118Fh ;18Fh
                call    ToneSet
                call    do_
                call    di_
                inc     si
                jmp     BuuuReent
BuuuEnd:
                mov     al,7
                out     37h,al
                mov     ax,04CDh
                call    ToneSet

                pop     si
                pop     ax
                pop     dx
                pop     bx
                ret

Buuu            ENDP

wait_5s         PROC   near
                push    cx
          @@:   
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al

                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
if 0
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al

endif
                out     5Fh,al
                out     5Fh,al
               loop     @b
                pop     cx
                ret
wait_5s         ENDP

wait_us         PROC   near
                push    cx
          @@:   
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b
                pop     cx
                ret
wait_us         ENDP
