;-------------------------------------------
;       Non-wait Keyboard input routine
;-------------------------------------------
KeyInput        PROC    near
                test    flagset,F_FDLOADER
                jnz     HardwareKeyInput
; KB BIOSg
                mov     ah,0
                int 18h
                xchg    al,ah
                mov     ah,0
                ret
HardwareKeyInput:
                push    di
                push    bx
                push    cx
                xor     ax,ax
                mov     bx,2400         ; Ƃ̒l 2400h
                mov     cx,4000h        ; Ƃ̒l 4000h
KeyInput_ent2:  
                cli
                call    Wait15us
KeyInput_ent:   
                in      al,43h
                test    al,02h ; status RDY
                jnz     KeyReady
                dec     cx
                or      cx,cx
                jnz     KeyInput_ent
                jmp     KeyTimeOut
KeyReady:       call    Wait15us
                in      al,41h
                clc
KeyInputEnd:    sti
;;;;;;;;;       call    dispkey
                pop     cx
                pop     bx
                pop     di
                ret
KeyTimeOut:     
;               mov     al,06h
;               out     37h,al
;               mov     cx,200h        ; Ƃ̒l 1000h
;eyBeep:        loop    KeyBeep
;                mov     al,07h
;                out     37h,al
                mov     cx,0E000h
                dec     bx
                or      bx,bx
                jz      KeyWaitTimeOut
                jmp     KeyInput_ent
KeyWaitTimeOut: ; wait counter time out
                stc
                jmp     KeyInputEnd
KeyInput        ENDP

Wait15us        PROC    near
                push    cx
                mov     cx,0018h
Wait15us_in:    out     5Fh,al  ; Ƃ͂̂P̂
                out     5Fh,al  ; ₵Ă݂
               loop     Wait15us_in
                pop     cx
                ret
Wait15us        ENDP
;----------------------------------------------------------------------
dispkey         PROC   near
                push    es
                push    ax
                mov     es,SegTVRAM
                mov     di,(80*1+74)*2
                mov     es:[di+2000h],byte ptr 0C5h
                pop     ax
                aad
                stosw
                pop     es
                ret
dispkey         ENDP